<?php

namespace App\Console\Commands;

use Carbon\Carbon;
use Codexshaper\WooCommerce\Facades\Product;
use Illuminate\Console\Command;
use App\Setting;
use App\Article;
use App\Mylog;
use Codexshaper\WooCommerce\Models\Product as ModelsProduct;
use Codexshaper\WooCommerce\Facades\Variation;
use Codexshaper\WooCommerce\Facades\Category;
use Illuminate\Support\Facades\DB;
use App\Services\ProductLogger;

class ProductUpdateGm extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'product:gmupdate';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Aggiorna prodotti da GM';

    /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Execute the console command.
     *
     * @return int
     */
    public function handle()
    {
        set_time_limit(0);
        ini_set("memory_limit", "512M");
        $settingora = Setting::where('key', 'update_products')->first();
        $productLogger = new ProductLogger($settingora, 'updateproducts', true);
        
        try {
            $productLogger->addLog('inserted', 'PRODOTTI INSERITI' . "\n");
            $productLogger->addLog('not_inserted', 'EVENTUALI PRODOTTI NON INSERITI' . "\n");
            $productLogger->addLog('updated', 'PRODOTTI AGGIORNATI' . "\n");
            $productLogger->addLog('server_issues', 'PRODOTTI NON INSERITI PER PROBLEMI SERVER' . "\n");
            $productLogger->addLog('pre_order', 'PRODOTTI IN PREVENDITA' . "\n");

            echo "SettingOra: " . $settingora;
            $fromtime = str_replace('-', '', $settingora->value);

            $articles = Article::join(DB::raw('(SELECT IdArticolo, MAX(DataOra) AS data FROM T_WEB_Articoli GROUP BY IdArticolo) b'), function ($join) {
                $join->on('T_WEB_Articoli.IdArticolo', '=', 'b.IdArticolo')
                    ->on('T_WEB_Articoli.DataOra', '=', 'b.data');
            })
                ->leftJoin(DB::raw('(SELECT e.IdStatoProdotto, e.Descrizione as DescrizioneStatoProdotto FROM T_WEB_StatiProdotto e JOIN (SELECT IdStatoProdotto, MAX(DataOra) as data1 from T_WEB_StatiProdotto GROUP BY IdStatoProdotto) c ON e.IdStatoProdotto = c.IdStatoProdotto AND e.DataOra = c.data1 ) f'), function ($join) {
                    $join->on('T_WEB_Articoli.IdStatoProdotto', '=', 'f.IdStatoProdotto');
                })
                ->leftJoin(DB::raw('(SELECT g.IdTipologia, g.Descrizione as DescrizioneTipologia FROM T_WEB_Tipologie g JOIN (SELECT IdTipologia, MAX(DataOra) as data1 from T_WEB_Tipologie GROUP BY IdTipologia) h ON g.IdTipologia = h.IdTipologia AND g.DataOra = h.data1 ) i'), function ($join) {
                    $join->on('T_WEB_Articoli.IdTipologia', '=', 'i.IdTipologia');
                })
                ->leftJoin(DB::raw('(SELECT l.IdTipoFormato, l.Descrizione as DescrizioneFormato FROM T_WEB_TipiFormato l JOIN (SELECT IdTipoFormato, MAX(DataOra) as data1 from T_WEB_TipiFormato GROUP BY IdTipoFormato) m ON l.IdTipoFormato = m.IdTipoFormato AND l.DataOra = m.data1 ) n'), function ($join) {
                    $join->on('T_WEB_Articoli.IdTipoFormato', '=', 'n.IdTipoFormato');
                })
                /*
                ->leftJoin(DB::raw('(SELECT o.Codice, o.QtaDisponibile FROM T_WEB_Disponibile o JOIN (SELECT Codice, MAX(DataOra) as data1 from T_WEB_Disponibile GROUP BY Codice) p ON o.Codice = p.Codice AND o.DataOra = p.data1 ) q'), function($join) {
                    $join->on('T_WEB_Articoli.IdArticolo', '=', 'q.Codice');
                })
                */

                //->where('T_WEB_Articoli.DataOra','>',$settingora->value)
                ->where('data', '>=', $fromtime)
                ->where(function ($query) {
                    $query->where('DescrizioneStatoProdotto', 'In commercio')
                        ->orWhere('DescrizioneStatoProdotto', 'In prevendita')
                        ->orWhere('DescrizioneStatoProdotto', 'Prossima uscita');
                })
                //->where('DescrizioneTipologia','Video Streaming')
                ->orderBy('Titolo')
                ->get();


            foreach ($articles as $article) {
                setProductFromGM($article, false, $productLogger);
            }

            $productLogger->setLogandSendEmail('Aggiornamento Prodotti');

            echo "************** Finito **************";
        } catch (\Exception $e) {
            echo $e->getMessage();

            if ($productLogger) {
                $productLogger->addLog('Error', $e->getMessage());
                $productLogger->setLogandSendEmail('Aggiornamento Prodotti');
            }
        }
    }
}
